package com.syc.slm.slmbi.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.google.common.collect.Maps;
import com.syc.slm.common.core.util.R;
import com.syc.slm.common.core.util.RestTemplateUtils;
import com.syc.slm.slmbi.dto.*;
import com.syc.slm.slmbi.entity.CurrentUser;
import com.syc.slm.slmbi.service.VariableService;
import com.syc.slm.slmbi.vo.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * slm-bi
 * 用户信息
 *
 * @author : lin
 * @date : 2021-03-25 18:45
 **/
@RestController
@RequestMapping("/{appId}/variables")
@Api(description = "变量控件", tags = "变量控件")
public class VariableController extends BaseRestController{
    @Autowired
    private VariableService variableService;



    @GetMapping("/test")
    public Map rest(){
        Map<String,String> maps = Maps.newHashMap();
//        @RequestParam(value = "token") String token,
//        @RequestParam(value = "equipment_info_id", required = false) String equipmentInfoId,
//        @RequestParam(value = "customer_id", required = false) String customerId,
//        @RequestParam(value = "q_name", required = false) String qName,
//        @RequestParam(value = "search_code", required = false, defaultValue = "false") boolean searchCode,
//        @RequestParam(value = "search_model", required = false, defaultValue = "false") boolean searchModel,
//        @RequestParam(value = "warranty_status", defaultValue = "0") int warrantStatus,
//        @RequestParam(value = "page_num", required = false, defaultValue = "1") int pageNum,
//        @RequestParam(value = "page_size", required = false, defaultValue = "15") int pageSize)
        maps.put("token","345aa488a820448dbb069ea4295d2b15");
        maps.put("appId","AAAAAA_9Cs4");
        maps.put("equipment_info_id",null);
        maps.put("customer_id",null);
        maps.put("q_name",null);
        maps.put("search_code",null);
        maps.put("search_model",null);
        maps.put("warranty_status",null);
        maps.put("page_num",null);
        maps.put("page_size",null);

        Map<String,String> heads = Maps.newHashMap();
        heads.put("token","345aa488a820448dbb069ea4295d2b15");
        R<List<PanelTreeNodeVo>> newR = new R<>();

        ResponseEntity<Map> rest = RestTemplateUtils.get(
            "http://localhost:2400/dc/{appId}/equipment/info/name/pull?token={token}&equipment_info_id={equipment_info_id}&customer_id={customer_id}&q_name={q_name}&search_code={search_code}&search_model={search_model}&warranty_status={warranty_status}&page_num={page_num}&page_size={page_size}",
            heads,
            Map.class,
            maps);
        if (rest != null){
            return rest.getBody();
        }
        return null;

    }

    @GetMapping
    @ApiOperation("获取变量列表")
    @ApiImplicitParam(name = "appId", value = "租户id", required = true,dataTypeClass = String.class)
    public R<IPage<VariableVo>> getVariableList(HttpServletRequest request,@PathVariable String appId, VariableDTO variableDTO) {
        return call(() -> {
            CurrentUser currentUser = getCurrentUser(request);
            return variableService.getVariableList(variableDTO,appId,currentUser.getToken(),dcClientHost+variableList);
        });
    }

    @GetMapping("/real-time")
    @ApiOperation("获取变量实时数据")
    @ApiImplicitParam(name = "appId", value = "租户id", required = true,dataTypeClass = String.class)
    public R<Map<String, List<Map<String, RealTimeVariableVo>>>> getVariableRealTimeDataList(@PathVariable String appId,
        VariableDataDTO variableDTO) {
        return call(()->(variableService.getVariableRealTimeDataList(variableDTO)));
    }

    @GetMapping("/source")
    @ApiOperation("获取变量来源列表,默认值6")
    @ApiImplicitParam(name = "appId", value = "租户id", required = true,dataTypeClass = String.class)
    public R<List<VariableSourceVo>> getVariableSourceList(@PathVariable String appId) {
        return call(()->variableService.getVariableSourceList());
    }

    @GetMapping("/device")
    @ApiOperation("获取变量所属设备列表")
    @ApiImplicitParam(name = "appId", value = "租户id", required = true,dataTypeClass = String.class)
    public R<IPage<VariableDeviceVo>> getVariableDeviceList(HttpServletRequest request,@PathVariable String appId, QueryPageDTO query) {
        return call(() -> {
            CurrentUser currentUser = getCurrentUser(request);
            return variableService.getVariableDeviceList(currentUser.getToken(),appId,dcClientHost+deviceList,query);
        });
    }

    @GetMapping("/history")
    @ApiOperation("获取变量历史数据")
    @ApiImplicitParam(name = "appId", value = "租户id", required = true,dataTypeClass = String.class)
    public R<Map<String, List<Map<String, HistoryVariableVo>>>> getVariableHistoryDataList(@PathVariable String appId,VariableDataDTO variableDTO) {
        return call(()->(variableService.getVariableHistoryDataList(variableDTO)));
    }

    @PostMapping("/send")
    @ApiOperation("下发")
    @ApiImplicitParam(name = "appId", value = "租户id", required = true,dataTypeClass = String.class)
    public R<Object> send(HttpServletRequest request,@PathVariable String appId,@RequestBody VariableSendDTO sendDTO) {
        return call(() -> {
            CurrentUser currentUser = getCurrentUser(request);
            variableService.send(sendDTO, currentUser,dcClientHost + deptsRoles);
        });
    }
}
