package com.syc.slm.slmbi.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.syc.slm.slmbi.dto.BusinessDTO;
import com.syc.slm.slmbi.entity.BusinessConfig;
import com.syc.slm.slmbi.entity.CurrentUser;
import com.syc.slm.slmbi.vo.BusinessConfigVo;

import java.util.List;
import java.util.Map;

/**
 * slm-bi
 * 系统业务表配置
 * @author : lin
 * @date : 2021-04-20 09:30
 **/
public interface BusinessConfigService extends IService<BusinessConfig> {
    /**
     * 获取系统业务表
     * @return
     */
    List<BusinessConfigVo> selectConfigList();

    /**
     * 根据id获取表配置
     * @param id
     * @return
     */
    BusinessConfigVo selectOneConfig(String id);

    /**
     * 字段数据
     * @param dto
     * @param uri
     * @param user
     * @return
     */
    List<Map<String,Object>> getBusinessData(BusinessDTO dto,String uri, CurrentUser user);
}
