package com.syc.slm.slmbi.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.syc.slm.slmbi.dto.QueryPageDTO;
import com.syc.slm.slmbi.dto.VariableDataDTO;
import com.syc.slm.slmbi.dto.VariableDTO;
import com.syc.slm.slmbi.dto.VariableSendDTO;
import com.syc.slm.slmbi.entity.CurrentUser;
import com.syc.slm.slmbi.vo.*;

import java.util.List;
import java.util.Map;

/**
 * slm-bi
 * 变量
 *
 * @author : lin
 * @date : 2021-03-25 16:17
 **/
public interface VariableService {
    /**
     * 获取变量列表
     * @param variableDTO
     * @return
     */
    IPage<VariableVo> getVariableList(VariableDTO variableDTO,String appId,String token,String uri);

    /**
     * 获取变量来源
     * @return
     */
    List<VariableSourceVo> getVariableSourceList();

    /**
     * 获取变量所属设备
     * @param token
     * @param appId
     * @param uri
     * @param queryPageDTO
     * @return
     */
    IPage<VariableDeviceVo> getVariableDeviceList(String token,String appId,String uri, QueryPageDTO queryPageDTO);

    /**
     * 获取实时数据
     * @param variableDTO
     * @return
     */
    Map<String, List<Map<String, RealTimeVariableVo>>> getVariableRealTimeDataList(VariableDataDTO variableDTO);

    /**
     * 获取历史数据
     * @param variableDTO
     * @return
     */
    Map<String, List<Map<String, HistoryVariableVo>>> getVariableHistoryDataList(VariableDataDTO variableDTO);

    /**
     * 下发
     * @param sendDTO
     * @param currentUser
     */
    void send(VariableSendDTO sendDTO, CurrentUser currentUser,String uri);
}
